
local InventoryInsight = InventoryInsight

InventoryInsight.racialTextures = {
    [ITEMSTYLE_NONE]    =   { styleName = "", styleTexture = ""},
    [ITEMSTYLE_RACIAL_ARGONIAN]    =   { styleName = "Argonian", styleTexture = "InventoryInsight/assets/argonian.dds"},
    [ITEMSTYLE_RACIAL_BRETON]    =   { styleName = "Breton", styleTexture = "InventoryInsight/assets/breton.dds"},
    [ITEMSTYLE_RACIAL_DARK_ELF]    =   { styleName = "Dark Elf", styleTexture = "InventoryInsight/assets/dunmer.dds"},
    [ITEMSTYLE_RACIAL_HIGH_ELF]    =   { styleName = "High Elf", styleTexture = "InventoryInsight/assets/altmer.dds"},
    [ITEMSTYLE_RACIAL_KHAJIIT]    =   { styleName = "Khajit", styleTexture = "InventoryInsight/assets/khajit.dds"},
    [ITEMSTYLE_RACIAL_NORD]    =   { styleName = "Nord", styleTexture = "InventoryInsight/assets/nord.dds"},
    [ITEMSTYLE_RACIAL_ORC]    =   { styleName = "Orc", styleTexture = "InventoryInsight/assets/orsimer.dds"},
    [ITEMSTYLE_RACIAL_REDGUARD]    =   { styleName = "RedGuard", styleTexture = "InventoryInsight/assets/redguard.dds"},
    [ITEMSTYLE_RACIAL_WOOD_ELF]    =   { styleName = "Wood Elf", styleTexture = "InventoryInsight/assets/bosmer.dds"},
    [10] = { styleName = "Unique", styleTexture = "/esoui/art/campaign/campaign_tabicon_leaderboard_up.dds"},
    [11] = { styleName = "Aldmeri Dominion", styleTexture = "InventoryInsight/assets/ancient.dds"},
    [12] = { styleName = "Ebonheart Pact", styleTexture = "InventoryInsight/assets/ebonheart.dds"},
    [13] = { styleName = "Daggerfall Covenant", styleTexture = "InventoryInsight/assets/daggerfall.dds"},
    [14] = { styleName = "Dwemer", styleTexture = "/esoui/art/campaign/campaign_tabicon_browser_up.dds"},
    [15] = { styleName = "Ancient Elf",styleTexture = "InventoryInsight/assets/ancient.dds"},
    [16] = { styleName = "Imperial", styleTexture = "InventoryInsight/assets/imperial.dds"},
    [17] = { styleName = "Reach", styleTexture = "InventoryInsight/assets/Reach.dds"},
    [ITEMSTYLE_ENEMY_BANDIT] = { styleName = "Bandit", styleTexture = "InventoryInsight/assets/Bandit.dds"},
    [ITEMSTYLE_ENEMY_PRIMITIVE] = { styleName = "Primitive", styleTexture = "InventoryInsight/assets/Primitive.dds"},
    [ITEMSTYLE_ENEMY_DAEDRIC] = { styleName = "Daedric", styleTexture = "InventoryInsight/assets/daedric.dds"},
    [21] = { styleName = "Warrior", styleTexture = "InventoryInsight/assets/bosmer.dds"},
    [22] = { styleName = "Mage", styleTexture = "InventoryInsight/assets/sorcerer.dds"},
    [23] = { styleName = "Rogue", styleTexture = "InventoryInsight/assets/nightblade.dds"},
    [24] = { styleName = "Summoner", styleTexture = "InventoryInsight/assets/sorcerer.dds"},
    [25] = { styleName = "Marauder", styleTexture = "InventoryInsight/assets/dragonknight.dds"},
    [26] = { styleName = "Healer", styleTexture = "InventoryInsight/assets/templar.dds"},
    [27] = { styleName = "Battlemage", styleTexture = "InventoryInsight/assets/dragonknight.dds"},
    [28] = { styleName = "Nightblade", styleTexture = "InventoryInsight/assets/nightblade.dds"},
    [29] = { styleName = "Ranger", styleTexture = "InventoryInsight/assets/nightblade.dds"},
    [30] = { styleName = "Knight", styleTexture = "InventoryInsight/assets/templar.dds"},
    [ITEMSTYLE_ENEMY_DRAUGR] = { styleName = "Draugr", styleTexture = "InventoryInsight/assets/Draugr1.dds"},  --undead
    [ITEMSTYLE_ENEMY_MAORMER] = { styleName = "Maormer", styleTexture = "InventoryInsight/assets/Maormer.dds"},  --snow elves
    [33] = { styleName = "Akaviri", styleTexture = "InventoryInsight/assets/Akaviri.dds"},  --samurai
    [34] = { styleName = "Imperial", styleTexture = "InventoryInsight/assets/imperial.dds"}
}

InventoryInsight.itemEquipTypeTextures = {
    [EQUIP_TYPE_CHEST]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_COSTUME]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_FEET]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_HAND]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_HEAD]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_INVALID]  =   "", 
    [EQUIP_TYPE_LEGS]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_MAIN_HAND]  =   "/esoui/art/inventory/inventory_tabicon_weapons_up.dds", 
    [EQUIP_TYPE_NECK]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_OFF_HAND]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_ONE_HAND]  =   "/esoui/art/inventory/inventory_tabicon_weapons_up.dds", 
    [EQUIP_TYPE_RING]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_SHOULDERS]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds", 
    [EQUIP_TYPE_TWO_HAND]  =   "/esoui/art/inventory/inventory_tabicon_weapons_up.dds", 
    [EQUIP_TYPE_WAIST]  =   "/esoui/art/inventory/inventory_tabicon_armor_up.dds" 
}

InventoryInsight.gearslotTextures = {
    [EQUIP_TYPE_CHEST] = "/esoui/art/characterwindow/gearslot_chest.dds",
    [EQUIP_TYPE_COSTUME] = "/esoui/art/characterwindow/gearslot_costume.dds",
    [EQUIP_TYPE_FEET] = "/esoui/art/characterwindow/gearslot_feet.dds",
    [EQUIP_TYPE_HAND] = "/esoui/art/characterwindow/gearslot_hands.dds",
    [EQUIP_TYPE_HEAD] = "/esoui/art/characterwindow/gearslot_head.dds",
    [EQUIP_TYPE_LEGS] = "/esoui/art/characterwindow/gearslot_legs.dds",
    [EQUIP_TYPE_MAIN_HAND] = "/esoui/art/characterwindow/gearslot_mainhand.dds",
    [EQUIP_TYPE_NECK] = "/esoui/art/characterwindow/gearslot_neck.dds",
    [EQUIP_TYPE_OFF_HAND] = "/esoui/art/characterwindow/gearslot_offhand.dds",
    [EQUIP_TYPE_ONE_HAND] = "/esoui/art/characterwindow/gearslot_mainhand.dds",
    [EQUIP_TYPE_RING] = "/esoui/art/characterwindow/gearslot_ring.dds",
    [EQUIP_TYPE_SHOULDERS] = "/esoui/art/characterwindow/gearslot_shoulders.dds",
    [EQUIP_TYPE_TWO_HAND] = "/esoui/art/characterwindow/gearslot_mainhand.dds",
    [EQUIP_TYPE_WAIST] = "/esoui/art/characterwindow/gearslot_belt.dds",
    [15] = "/esoui/art/characterwindow/gearslot_tabard.dds"
}

function InventoryInsight.IN2_AddWornItemControls( queryResults, tooltip)
    if(queryResults)then
        if(#queryResults.locations > 0)then
            for x, location in pairs(queryResults.locations) do
                local itemLink = queryResults.link
                local item = InventoryInsight.data.DBv2[itemLink]
                local itemLocation = item[location.name]
                if(itemLocation)then
                    local wornItem = itemLocation.worn
                    if(wornItem)then
                        local gearslotTexture = InventoryInsight.gearslotTextures[wornItem]
                        local wornItemIndicator = WINDOW_MANAGER:GetControlByName("IN2_wornItemIndicator")
                        if(wornItemIndicator == nil)then
                            local wornItemIndicator = WINDOW_MANAGER:CreateControl("IN2_wornItemIndicator", tooltip, CT_TEXTURE)
                            wornItemIndicator:SetDimensions(20,20)
                            wornItemIndicator:SetTexture(gearslotTexture)
                            wornItemIndicator:SetTextureCoords(0,1,0,1)
                            wornItemIndicator:SetAlpha(1)
                            wornItemIndicator:SetHidden(false)
                            tooltip:AddControl(wornItemIndicator, x, false)
                            wornItemIndicator:SetAnchor(CENTER)
                        else
                            wornItemIndicator:SetTexture(gearslotTexture)  
                            wornItemIndicator:SetHidden(false)                      
                            tooltip:AddControl(wornItemIndicator, x, false)
                            wornItemIndicator:SetAnchor(CENTER)
                        end
                    end
                end
            end
        end
    end
end

function InventoryInsight.IN2_ProcessItemAttribs( control, itemLink ) 
    local _modified = false
    if(control == IN2_ITEM_TOOLTIP or control == IN2_POPUP_TOOLTIP) then
        if(itemLink and itemLink ~= "") then
            --Use IN2_DissectItemLink() to get some attributes from link...
            local itemID, 
            itemText, 
            itemLevel, 
            itemQuality, 
            itemColor, 
            itemStyle, 
            itemType, 
            itemEnchantmentType, 
            itemEnchantmentStrength1, 
            itemEnchantmentStrength2, 
            itemIsBound, 
            itemChargeStatus = InventoryInsight.IN2_DissectItemLink(itemLink)
            --Then use ZO function to get the rest...
            local itemIcon, 
            itemSellPrice, 
            itemMeetsUsageRequirement, 
            itemEquipType = GetItemLinkInfo(itemLink)            
            -----------------------------------------------------------------------------------

            local raceTex = ""
            if(itemStyle and (tonumber(itemStyle) <= #InventoryInsight.racialTextures)) then
                raceTex = InventoryInsight.racialTextures[tonumber(itemStyle)].styleTexture
            end
            if(raceTex ~= "") then
                control.RaceIcon:SetTexture(raceTex)
                control.RaceIcon:SetAlpha(1)
                _modified = true
            else            
                control.RaceIcon:SetTexture("")
                control.RaceIcon:SetAlpha(0)        
            end

            local typeTex = ""
            if(itemEquipType and (tonumber(itemEquipType) <= #InventoryInsight.itemEquipTypeTextures)) then
                typeTex = InventoryInsight.itemEquipTypeTextures[tonumber(itemEquipType)]
            end
            if(typeTex ~= "") then
                control.TypeIcon:SetTexture(typeTex)
                control.TypeIcon:SetAlpha(1)
                _modified = true
            else            
                control.TypeIcon:SetTexture("")
                control.TypeIcon:SetAlpha(0)        
            end

            local styleName = ""
            if(itemStyle and (tonumber(itemStyle) <= #InventoryInsight.racialTextures)) then
                styleName = InventoryInsight.racialTextures[tonumber(itemStyle)].styleName
            end
            if(styleName ~= "") then
                control.StyleLabel:SetText(styleName)
                control.StyleLabel:SetHidden(false)
                _modified = true
            else          
                control.StyleLabel:SetText("")
                control.StyleLabel:SetHidden(true)           
            end

            InventoryInsight.IN2_DebugOutput("itemStyle:"..itemStyle.." styleName:"..styleName.." racialTextures:"..raceTex)
        else
            InventoryInsight.IN2_DebugOutput(control:GetName()..":Bad or no item link - can't process item attributes!")
        end
    end
    return _modified
end

function InventoryInsight.IN2_IN2ToolTipShowHandler( control, ... )	
	control.IN2_HasModified = false;
	if(control == IN2_ITEM_TOOLTIP) then
	    if control.animation then
	        control.animation:Stop()
	    end
	    control:SetAlpha(1)
		local mouseOverControl = moc();
		if(mouseOverControl ~= nil) then
            local mocParent = mouseOverControl:GetParent()
            if(mocParent)then
                if(mouseOverControl.dataEntry and mouseOverControl.dataEntry.data.bagId and mouseOverControl.dataEntry.data.slotIndex) then --is inventroy
                    local bag = mouseOverControl.dataEntry.data.bagId;
                    local index = mouseOverControl.dataEntry.data.slotIndex;
                    local curMouseOverLink = GetItemLink(bag, index, LINK_STYLE_BRACKETS);
                    InventoryInsight.IN2_HandleTooltipRAIntegration(bag, index, control)
                    IN2_CURRENT_MOUSEOVER_LINK = curMouseOverLink;
                elseif(mouseOverControl:GetParent():GetName() == "ZO_Character") then --is worn item
                    local bag = mouseOverControl.bagId;
                    local index = mouseOverControl.itemIndex;
                    local curMouseOverLink = GetItemLink(bag, index, LINK_STYLE_BRACKETS);
                    InventoryInsight.IN2_HandleTooltipRAIntegration(bag, index, control)
                    IN2_CURRENT_MOUSEOVER_LINK = curMouseOverLink;
                elseif(mouseOverControl:GetParent():GetName() == "ZO_StoreWindowListContents") then --is store item
                    local curMouseOverLink = GetStoreItemLink(mouseOverControl.index, LINK_STYLE_BRACKETS)
                    IN2_CURRENT_MOUSEOVER_LINK = curMouseOverLink;            
                elseif(mouseOverControl:GetParent():GetName() == "ZO_BuyBackListContents") then --is store item
                    local curMouseOverLink = GetBuybackItemLink(mouseOverControl.index, LINK_STYLE_BRACKETS)
                    IN2_CURRENT_MOUSEOVER_LINK = curMouseOverLink;
                elseif(mouseOverControl:GetParent():GetName() == "ZO_InteractWindowRewardArea") then --is store item
                    local curMouseOverLink = GetQuestRewardItemLink(mouseOverControl.index, LINK_STYLE_BRACKETS)
                    IN2_CURRENT_MOUSEOVER_LINK = curMouseOverLink;          
                elseif(mouseOverControl:GetParent():GetName() == "ZO_LootAlphaContainerListContents") then --is loot item
                    local index = mouseOverControl.dataEntry.data.lootId;
                    local curMouseOverLink = GetLootItemLink(index, LINK_STYLE_BRACKETS)
                    IN2_CURRENT_MOUSEOVER_LINK = curMouseOverLink;                                     
                end
            end
		end
	else --Control is IN2_POPUP_TOOLTIP
		control.lastLink = PopupTooltip.lastLink
	end
end

function InventoryInsight.IN2_HandleTooltipRAIntegration(bagId, slotIndex, control)
    if(InventoryInsight.RASLoaded and InventoryInsight.settings.in2RASResearchableTooltipIcon) then 
        if(bagId and slotIndex)then
            local researchable = InventoryInsight.RAS_IsItemResearchable(bagId, slotIndex)
            if(researchable)then
                control.RAIntegration:SetAlpha(1)
            else
                control.RAIntegration:SetAlpha(0)
            end
        else --Passed nil to research control
            control.RAIntegration:SetAlpha(0)
        end
    end
end

function InventoryInsight.IN2_IN2ToolTipHideHandler( control, ... )
	control.IN2_HasModified = false;
	if(control == IN2_ITEM_TOOLTIP) then
		IN2_CURRENT_MOUSEOVER_LINK = nil;
        control.RaceIcon:SetTexture("")
        control.RaceIcon:SetAlpha(0)
        control.TypeIcon:SetTexture("")
        control.TypeIcon:SetAlpha(0)
        control.StyleLabel:SetText("")
        control.StyleLabel:SetHidden(true)   
        control.IN2_Left = 0
        control.IN2_Top = 0
		--control.animation:Stop()
        control:ClearAnchors()
        control:SetAnchor(TOP, ItemTooltip, BOTTOM, 0, 0)
        InventoryInsight.IN2_HandleTooltipRAIntegration(nil, nil, control)
	end	
    if(control == IN2_POPUP_TOOLTIP) then
        control.curAnchorPoint = BOTTOM 
        control:ClearAnchors()
        control:SetAnchor(TOP, PopupTooltip, BOTTOM, 0, 0)
    end 
    --[[
    local wornItemIndicator = WINDOW_MANAGER:GetControlByName("IN2_wornItemIndicator")
    if(wornItemIndicator)then
        wornItemIndicator:SetHidden(true)
        wornItemIndicator:ClearAnchors()
    end]]
	control:ClearLines()
end

function InventoryInsight.IN2_AdjustTooltipPadding(control, minimal)
    local defaultX = 32
    local defaultY = 57
    if(control)then
        if(minimal)then
            control:SetResizeToFitPadding(32,17)
        else
            control:SetResizeToFitPadding(defaultX,defaultY)
        end
    end
end

function InventoryInsight.IN2_CreateIN2ItemTooltipFrame()
    local ItemTooltip = ItemTooltip
	local height = 200
	local frame = WINDOW_MANAGER:CreateControlFromVirtual("IN2_ITEM_TOOLTIP", ItemTooltipTopLevel, "ItemTooltipBase")
    frame:ClearAnchors()
    frame:SetAnchor(TOP, ItemTooltip, BOTTOM, 0, 0) 
    frame:SetDimensions(ItemTooltip:GetWidth(), height)
    frame.controlType = CT_CONTROL
    frame.system = SETTING_TYPE_UI
    frame:SetHidden(true)
    frame:SetMouseEnabled(false)
    frame:SetMovable(false)
    frame:SetClampedToScreen(true)

    InventoryInsight.IN2_AdjustTooltipPadding(frame, InventoryInsight.settings.in2IN2TooltipsMinimalPadding)  
    InventoryInsight.IN2_AdjustTooltipPadding(ItemTooltip, InventoryInsight.settings.in2DefaultTooltipsMinimalPadding)  

    ItemTooltip.animation = ANIMATION_MANAGER:CreateTimelineFromVirtual("TooltipFadeOutAnimation", ItemTooltip)
    ItemTooltip.animation:GetAnimation():GetTimeline():InsertCallback(function(...) IN2_ITEM_TOOLTIP.animation:PlayFromStart() end, 0)
    ItemTooltip.animation:GetAnimation():GetTimeline():InsertCallback(function(...) IN2_ITEM_TOOLTIP:SetHidden(true) end, 50)
    
    frame.animation = ANIMATION_MANAGER:CreateTimelineFromVirtual("TooltipFadeOutAnimation", frame)
    frame.animation:SetHandler("OnStop", function(animation)
        if animation:GetProgress() == 1.0 then
            frame:SetHidden(true)
		    frame:SetAlpha(1)
        end
    end)

    frame:SetHandler("OnShow", InventoryInsight.IN2_IN2ToolTipShowHandler)
    frame:SetHandler("OnUpdate", function(...)
        local _modified = false
    	if((frame:GetLeft() ~= frame.IN2_Left) or (frame:GetTop() ~= frame.IN2_Top)) then
    		frame:ClearLines()
            InventoryInsight.IN2_IN2ToolTipShowHandler(...)  
		    local queryResults, processedAtribs = InventoryInsight.IN2_TooltipUpdateHandler(...)
            --InventoryInsight.IN2_AddWornItemControls( queryResults, frame)
            if(queryResults) then
                if(#queryResults.locations < 1) then
                    frame:AddLine(" ");
                    ZO_Tooltip_AddDivider(frame); 
                else
                    _modified = true
                end
            end
            if(processedAtribs) then
                _modified = true
            end
		    frame.IN2_Left = frame:GetLeft() 
	    	frame.IN2_Top = frame:GetTop()
            if(frame:GetTop() < ItemTooltip:GetBottom()) then
                frame:ClearAnchors()
                frame:SetAnchor(BOTTOM, ItemTooltip, TOP, 0, 0) 
            end
            if(not _modified) then
                frame:SetHidden(true)
            end
	    end
	end)
    frame:SetHandler("OnHide", InventoryInsight.IN2_IN2ToolTipHideHandler)


    frame.RaceIcon = WINDOW_MANAGER:CreateControl(frame:GetName().."RaceIcon", frame, CT_TEXTURE)
    frame.RaceIcon:SetDimensions(60,60)
    frame.RaceIcon:SetAnchor(TOPRIGHT, frame, TOPRIGHT, -2, 2)
    frame.RaceIcon:SetTexture("")
    frame.RaceIcon:SetTextureCoords(0,1,0,1)
    frame.RaceIcon:SetAlpha(0)

    frame.StyleLabel = WINDOW_MANAGER:CreateControl(frame:GetName().."StyleLabel", frame, CT_LABEL)
    local StyleLabel = frame.StyleLabel
    StyleLabel:SetAnchor(RIGHT, frame.RaceIcon, LEFT, -2, 0)
    StyleLabel:SetFont("ZoFontWinH4") -- ZoFontWinH4
    StyleLabel:SetText("")
    StyleLabel:SetHidden(true)

    frame.TypeIcon = WINDOW_MANAGER:CreateControl(frame:GetName().."TypeIcon", frame, CT_TEXTURE)
    frame.TypeIcon:SetDimensions(60,60)
    frame.TypeIcon:SetAnchor(TOPLEFT, frame, TOPLEFT, 2, 2)
    frame.TypeIcon:SetTexture("")
    frame.TypeIcon:SetTextureCoords(0,1,0,1)
    frame.TypeIcon:SetAlpha(0)


    frame.label = WINDOW_MANAGER:CreateControl(frame:GetName().."Label", frame, CT_LABEL)
    local label = frame.label
    --label:SetDimensions(290, 24)
    label:SetAnchor(TOP, frame, TOP, 0, 5)
    label:SetFont("ZoFontBookPaper") -- ZoFontWinH4
    label:SetText("-Inventory Insight-")
    --label:SetHidden(true)

    if(InventoryInsight.RASLoaded)then
        frame.RAIntegration = WINDOW_MANAGER:CreateControl(frame:GetName().."RAIntegration", frame, CT_TEXTURE)
        local RAIntegration = frame.RAIntegration
        RAIntegration:SetDimensions(25,25)
        RAIntegration:SetAnchor(LEFT, frame.TypeIcon, RIGHT, -10, 0)
        --RAIntegration:SetTexture("/esoui/art/inventory/newitem_icon.dds")
        RAIntegration:SetTexture(InventoryInsight.Integrations.RATooltipIcons[InventoryInsight.settings.in2RASResearchableTooltipIconStyle])
        --RAIntegration:SetTexture("InventoryInsight/assets/ra_icon.dds")
        RAIntegration:SetTextureCoords(0,1,0,1)
        RAIntegration:SetColor(1, .25, 0, 1)
        RAIntegration:SetAlpha(0)
    end

    --[[
    frame.logo = WINDOW_MANAGER:CreateControl(nil,frame,CT_TEXTURE)
    frame.logo:SetDimensions(120,120)
    frame.logo:SetAnchor(CENTER, frame, CENTER,0, 0)
    frame.logo:SetTexture("InventoryInsight/assets/inventoryinsight_icon.dds") -- texture will toggle based on current sort
    frame.logo:SetTextureCoords(0,1,0,1)
    frame.logo:SetAlpha(.10)
    ]]

    return frame
end

function InventoryInsight.IN2_CreateIN2PopupTooltipFrame()
    local PopupTooltip = PopupTooltip
	local height = 200
	local frame = WINDOW_MANAGER:CreateControlFromVirtual("IN2_POPUP_TOOLTIP", PopupTooltipTopLevel, "ItemTooltipBase")
    frame:ClearAnchors()
    frame:SetAnchor(TOP, PopupTooltip, BOTTOM, 0, 0) 
    frame.curAnchorPoint = BOTTOM
    frame:SetDimensions(PopupTooltip:GetWidth(), height)
    frame.controlType = CT_CONTROL
    frame.system = SETTING_TYPE_UI
    frame:SetHidden(true)
    frame:SetMouseEnabled(false)
    frame:SetMovable(false)
    frame:SetClampedToScreen(true)

    InventoryInsight.IN2_AdjustTooltipPadding(frame, InventoryInsight.settings.in2IN2TooltipsMinimalPadding)  
    InventoryInsight.IN2_AdjustTooltipPadding(PopupTooltip, InventoryInsight.settings.in2DefaultTooltipsMinimalPadding)  

    frame:SetHandler("OnShow", InventoryInsight.IN2_IN2ToolTipShowHandler)
    frame:SetHandler("OnUpdate", function(...)
        local _modified = false
    	if(frame.lastLink ~= PopupTooltip.lastLink) then
    		frame.IN2_HasModified = false
    		frame:ClearLines()
	    	frame.lastLink = PopupTooltip.lastLink
            local queryResults, processedAtribs = InventoryInsight.IN2_TooltipUpdateHandler(...)
            if(queryResults) then
                if(#queryResults.locations < 1) then
                    frame:AddLine(" ");
                    ZO_Tooltip_AddDivider(frame); 
                else
                    _modified = true
                end
            end
            if(processedAtribs) then
                _modified = true
            end
            if(not _modified) then
                frame:SetHidden(true)
            end   
	    end
        if(frame.curAnchorPoint == BOTTOM and frame:GetTop() < PopupTooltip:GetBottom()) then
            frame.curAnchorPoint = TOP 
            frame:ClearAnchors()
            frame:SetAnchor(BOTTOM, PopupTooltip, TOP, 0, 0) 
        elseif(frame.curAnchorPoint == TOP and frame:GetBottom() > PopupTooltip:GetTop()) then
            frame.curAnchorPoint = BOTTOM 
            frame:ClearAnchors()
            frame:SetAnchor(TOP, PopupTooltip, BOTTOM, 0, 0)
        end    
	end)
    frame:SetHandler("OnHide", InventoryInsight.IN2_IN2ToolTipHideHandler)

    frame.RaceIcon = WINDOW_MANAGER:CreateControl(frame:GetName().."RaceIcon", frame, CT_TEXTURE)
    frame.RaceIcon:SetDimensions(60,60)
    frame.RaceIcon:SetAnchor(TOPRIGHT, frame, TOPRIGHT, -2, 2)
    frame.RaceIcon:SetTexture("")
    frame.RaceIcon:SetTextureCoords(0,1,0,1)
    frame.RaceIcon:SetAlpha(0)

    frame.StyleLabel = WINDOW_MANAGER:CreateControl(frame:GetName().."StyleLabel", frame, CT_LABEL)
    local StyleLabel = frame.StyleLabel
    StyleLabel:SetAnchor(RIGHT, frame.RaceIcon, LEFT, -2, 0)
    StyleLabel:SetFont("ZoFontWinH4") -- ZoFontWinH4
    StyleLabel:SetText("")
    StyleLabel:SetHidden(true)

    frame.TypeIcon = WINDOW_MANAGER:CreateControl(frame:GetName().."TypeIcon", frame, CT_TEXTURE)
    frame.TypeIcon:SetDimensions(60,60)
    frame.TypeIcon:SetAnchor(TOPLEFT, frame, TOPLEFT, 2, 2)
    frame.TypeIcon:SetTexture("")
    frame.TypeIcon:SetTextureCoords(0,1,0,1)
    frame.TypeIcon:SetAlpha(0)

    frame.label = WINDOW_MANAGER:CreateControl(frame:GetName().."Label", frame, CT_LABEL)
    local label = frame.label
    --label:SetDimensions(290, 24)
    label:SetAnchor(TOP, frame, TOP, 0, 5)
    label:SetFont("ZoFontBookPaper") -- ZoFontWinH4
    label:SetText("-Inventory Insight-")
    --label:SetHidden(true)

    --[[
    frame.logo = WINDOW_MANAGER:CreateControl(nil,frame,CT_TEXTURE)
    frame.logo:SetDimensions(120,120)
    frame.logo:SetAnchor(CENTER, frame, CENTER,0, 0)
    frame.logo:SetTexture("InventoryInsight/assets/inventoryinsight_icon.dds") -- texture will toggle based on current sort
    frame.logo:SetTextureCoords(0,1,0,1)
    frame.logo:SetAlpha(.10)
    ]]
    
    return frame
end

--[[
function InventoryInsight.IN2_ToolTipMonitorCallback(millisecondsRunning)
]]

--[[
function InventoryInsight.IN2_RegisterIN2TooltipsForUpdates( register )
]]